package tree

import (
	"fmt"
	"math/big"
	"testing"
	"time"

	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/crypto"
)

func TestMT(t *testing.T) {
	proofs := make([]common.Hash, 0)

	for i := 1; i < 6; i++ {
		_proof := crypto.Keccak256Hash(big.NewInt(0).SetInt64(int64(i)).Bytes())
		proofs = append(proofs, _proof)
	}

	// address := common.HexToAddress("0x1f9090aaE28b8a3dCeaDf281B0F12828e676c326")
	// amount := big.NewInt(0).SetUint64(10)
	// payload := append(address.Bytes(), common.LeftPadBytes(amount.Bytes(), 32)...)
	// data := crypto.Keccak256Hash(payload)
	// proofs = append(proofs, data)
	st := time.Now()

	tree, err := NewMerkleTree(proofs)
	if err != nil {
		t.Fatal(err)
	}

	// mproofs, err := tree.GetProof(data)
	// if err != nil {
	// 	t.Fatal(err)
	// }
	// _ = mproofs
	t.Log("root:", tree.GetRoot().Hex())

	// for _, el := range mproofs {
	// t.Log(hex.EncodeToString(el[:]))
	// }
	t.Log("---")
	for i := len(tree.layers) - 1; i >= 0; i-- {
		fmt.Println(len(tree.layers[i]), tree.layers[i])
		if i < len(tree.layers)-5 {
			break
		}
	}
	t.Log("---")
	t.Log(time.Since(st))

	// tnode := tree.FindMerkleNode(common.HexToHash("0xa05a2b09dda15efbc0e7a2f9cd779d902d765c5ecb1abb3ef06a450f55a9fce7"))
	// t.Log("tnode", tnode)
	// t.Log(time.Since(st))

	layers := MerkleTreeTraversal(tree.treeNode, 5)
	t.Log(time.Since(st))

	for _, layer := range layers {
		fmt.Println(len(layer), layer)
	}

	// nodes := [][]common.Hash{}
	// for i := len(tree.layers) - 1; i >= 0; i-- {
	// 	layer := tree.layers[i]
	// 	if len(layer)%2 == 1 && i != len(tree.layers)-1 {
	// 		layer = append(layer, common.Hash{})
	// 	}
	// 	nodes = append(nodes, layer)
	// 	t.Log(layer)
	// }
	// t.Log("==")
	// t.Log(nodes)
	// treeNode := buildTree(nodes)
	// t.Log("---")
	// levelOrderTraversal(treeNode, common.HexToHash("0xad793b7e9f57201b9bfa52639a3a5ca6fe86cca2b69adf5295cf5f9fd2a5d12a"), 3)

}
